// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------

// dll_averageDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "dll_average.h"
#include "dll_averageDlg.h"
#include "LicenceDlg.h"
#include "ConfFileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDll_averageDlg _CAO

CDll_averageDlg::CDll_averageDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDll_averageDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDll_averageDlg)
	m_averagedensity = _T("");
	m_executetime = _T("");
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDll_averageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDll_averageDlg)
	DDX_Text(pDX, IDC_AVERAGEDENSITY, m_averagedensity);
	DDX_Text(pDX, IDC_EXECUTETIME, m_executetime);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDll_averageDlg, CDialog)
	//{{AFX_MSG_MAP(CDll_averageDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_LOADIMAGE, OnLoadimage)
	ON_BN_CLICKED(IDC_SAVEIMAGE, OnSaveimage)
	ON_BN_CLICKED(IDC_RECALC, OnRecalc)
	ON_BN_CLICKED(IDC_EXEREGION, OnExeregion)
	ON_BN_CLICKED(IDC_GRAB, OnGrab)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDll_averageDlg bZ[W nh

BOOL CDll_averageDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	/* -------------------------------------------------------------------------------- */
	// FvxSample 
	CLicenceDlg dlg;
	CConfFileDlg fdlg;

	// CZXʂ̕\
	if (dlg.DoModal() == IDOK){

		//Ӂ
		// ߂COM̏sƂYȂłB
		CoInitialize( NULL );
		CWnd *pwnd ;
		IUnknown *p_unknown;
		long err_no = 0 ;

		// _CAOɓ\tĂFvxDisplayEx̃CX^X擾AX}[g|C^Ɋt܂B
		pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );		// FvxDisplayEx̃nh擾
		p_unknown = pwnd->GetControlUnknown();		// Rg[̎IUnknownC^[tFCX擾
		p_unknown->QueryInterface( __uuidof(IFvxDisplayEx2Ptr) , (void**)&m_FvxDisplayEx );

		// eFvxRg[̃CX^X𐶐܂B
		// w肷NXԈႦȂ悤ӂĂB
		m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) ); 
		m_FvxImage.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) ); 
		m_FvxROI.CreateInstance( __uuidof( FvxROI ) ); 
		m_FvxPerformanceCounter.CreateInstance( __uuidof( FvxPerformanceCounter ) ); 
		m_ExeRegion.CreateInstance( __uuidof( FvRectangle ) ); 

		// fBXvC̏
		m_FvxDisplayEx->CreateDisplay( 1 , 0 );

		// J荞ݗL
		GetDlgItem( IDC_GRAB )->EnableWindow( FALSE );
		// rfIfoCX̏ԂL
		m_blnVideoOpened = false;

		// ͈͂̏lݒ
		m_ExeRegion->Putxs( 130 );
		m_ExeRegion->Putxe( 180 );
		m_ExeRegion->Putys( 110 );
		m_ExeRegion->Putye( 190 );
                
		// ϔZxlvZ
		Recalc();

		// rfIݒt@C̑I
		fdlg.DoModal();

		if ( fdlg.m_check == FALSE ) {
			
		    // rfIݒt@CR|[lgɐݒ
 			m_FvxVideo->PutVideoConfFile( _bstr_t( fdlg.m_conffile ));

			// rfIfoCXI[v
			try {

				m_FvxVideo->OpenDevice();

			} catch( _com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfIfoCX̃I[vɎs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
			}

			// VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
			// ̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
			// {vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
			// g̃Lv`{[hɍ킹ĕύXĂB
			::Sleep( 350 );

			// GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
            // 炩ChangeImageSize\bhɂImagẽTCYύXĂ
            //i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
			m_FvxVideo->ChangeImageSize( m_FvxImage );

			try	{

				// 捞
				m_FvxVideo->GrabSync( m_FvxImage );

			} catch(_com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfI̎捞Ɏs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B

			}

			// J荞ݗL
			GetDlgItem( IDC_GRAB )->EnableWindow( TRUE );
			// rfIfoCX̏ԂL
			m_blnVideoOpened = true;

		}

		// 摜̕\
		m_FvxDisplayEx->DrawImage( m_FvxImage );
              
		// ϔZxlvZ
		Recalc();

	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}
	
	UpdateData( FALSE ); 
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B

}

void CDll_averageDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CDll_averageDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CDll_averageDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDll_averageDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	if (IsIconic() == 0 ) {

		if ( m_FvxDisplayEx != NULL ){
			CWnd *pwnd;
			CRect rect;

			pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
			pwnd->GetWindowRect( rect );

			// XN[WNCAgWɕϊ
			ScreenToClient( rect );

			// FvxDisplayEx̃TCYύX
			pwnd->MoveWindow( rect.left , rect.top, cx - (rect.left + 20) , cy - (rect.top + 20) , TRUE );

		}
	}
}

// ČvZ
void CDll_averageDlg::Recalc()
{
    
    // ϒl𑪒肷͈͂ŕ\
    m_FvxDisplayEx->ClearOverlay( -1 );
    m_FvxDisplayEx->PutPenColor(RGB(0, 0, 255));
    m_FvxDisplayEx->DrawData( 0, m_ExeRegion );
    
    // ԌvJn
    m_FvxPerformanceCounter->StartCount();
    
    // C[W̐擪AhX擾
	long lngImageAddress = 0;
    m_FvxImage->GetImageAdrs( &lngImageAddress, 0 );
    
    // w͈͂̕ϒlAreaAverageɂČvZ
    double dblAve = AreaAverage(lngImageAddress, m_FvxImage->GetImageWidth(), m_FvxImage->GetImageHeight(), m_FvxImage->GetBitPerPixel(),(long)m_ExeRegion->Getxs(), (long)m_ExeRegion->Getys(), (long)m_ExeRegion->Getxe(), (long)m_ExeRegion->Getye());

    // ԌvI
    double dblTime = 0;
    m_FvxPerformanceCounter->StopCount( &dblTime );
    
    if ( dblAve == -1 ) {
        m_averagedensity = "G[";
	} else {
		m_averagedensity.Format( "%.1f",dblAve );
	}
		
    m_executetime.Format("%.2fms",dblTime);
	UpdateData( FALSE );

}

// 摜t@CǍ
void CDll_averageDlg::OnLoadimage() 
{
	// R_CAONX̐
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){
		m_FvxFileAccess->PutFilePath( _bstr_t( cFileDlg.GetPathName() ) );

		try {
		
			m_FvxFileAccess->LoadBitmap( m_FvxImage );
		
		} catch(_com_error ) {

			long lngErr;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("Ǎ݂Ɏs܂Berr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}

		// 摜^Cv`FbN
		if (( m_FvxImage->GetImageType ()!= imageGray ) || ( m_FvxImage->GetBitPerPixel()!= 8 ) || 
			( m_FvxImage->GetImageWidth ()!= 512 ) || ( m_FvxImage->GetImageHeight()!= 480 )) {

			MessageBox("512*480 8bitOC̉摜ł͂܂","G[", MB_ICONWARNING | MB_OK);

            m_FvxImage->PutBitPerPixel( 8 );
            m_FvxImage->PutImageType( imageGray );
            m_FvxImage->PutImageWidth( 512 );
            m_FvxImage->PutImageHeight( 480 );
		}

        m_FvxDisplayEx->DrawImage( m_FvxImage );

		// ϔZxlvZ
		Recalc();

	}
}

// 摜t@Cۑ
void CDll_averageDlg::OnSaveimage() 
{
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath ( _bstr_t( cFileDlg.GetPathName() ));

		try {
		
			m_FvxFileAccess->SaveBitmap( m_FvxImage );
		
		} catch(_com_error ) {

			long lngErr;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
}

void CDll_averageDlg::OnRecalc() 
{
	// ϔZxlvZ
	Recalc();
}

// ͈͂̐ݒ
void CDll_averageDlg::OnExeregion() 
{

    long lngOK = 0;
    
    m_FvxROI->SetRectangle( m_ExeRegion );
    
    // FvxROIgď͈͑I_CAOo܂
    m_FvxROI->PutUsePoint( FALSE );
    m_FvxROI->MakeROIDialog( m_FvxImage, &lngOK );
    
    if ( ( lngOK == 1 ) &&  ( m_FvxROI->GetCheckRectangle() == 1 )) {
        m_FvxROI->GetRectangle( m_ExeRegion );
        
        // n_ƏI_tɂȂĂȂ`FbN܂
        // FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
        // tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ
        double dblTemp = 0;
		if ( m_ExeRegion->Getxe() < m_ExeRegion->Getxs() ) {
            dblTemp = m_ExeRegion->Getxs();
            m_ExeRegion->Putxs( m_ExeRegion->Getxe() );
            m_ExeRegion->Putxe( dblTemp );
		}
		if ( m_ExeRegion->Getye() < m_ExeRegion->Getys() ) {
            dblTemp = m_ExeRegion->Getys();
            m_ExeRegion->Putys( m_ExeRegion->Getye() );
            m_ExeRegion->Putye( dblTemp );
		}
	}
		
    // ϒľvZ
    Recalc();
	
}

void CDll_averageDlg::OnGrab() 
{
    // 摜t@Cǂݍ݂ɂāA摜TCY
    // ύXĂ\邽߁AChangeImageSizes܂B
    // 摜TCYύX\ꍇ́AɈxsΖL܂B
    m_FvxVideo->ChangeImageSize( m_FvxImage );
    
    // 捞
    m_FvxVideo->GrabSync( m_FvxImage );
    // 荞񂾉摜ʂɕ\
    m_FvxDisplayEx->DrawImage( m_FvxImage );
    
    // ϒľvZ
    Recalc();
}

BOOL CDll_averageDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	if(pMsg->message == WM_KEYDOWN)
	{
		switch( pMsg->wParam )
		{
			case VK_RETURN:
			case VK_ESCAPE:
				return false;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}

/* ------------------------------------------------------------------------
	double AreaAverage
		ẅ̉f̕ϔZx߂܂B
		8bitOC摜płB

	
		long lImageAddres	摜̐擪AhX
		long lImageSizeX	摜XTCY
		long lImageSizeY	摜YTCY
		long lImageBPP		摜BPPl
		long lsx	ς߂̈̍XW
		long lsy	ς߂̈̍YW
		long lex	ς߂̈̉EXW
		long ley	ς߂̈̉EYW
	Ԓl
		IF@߂ꂽϔZxl
		ُIF@-1
 ------------------------------------------------------------------------- */
double CDll_averageDlg::AreaAverage(long lImageAddress, long lImageSizeX, long lImageSizeY, long lImageBPP, long lsx, long lsy, long lex, long ley)
{
	unsigned char *pImageTop;
	long i,j;

	double dAverage = 0.0;

	// BPP8ȊOُ͈̎I
	if( lImageBPP != 8 ) return -1;
	
	// n_ƏI_ւĂC
	if( lsx > lex ){
		i = lsx;
		lex = lsx;
		lsx = i;
	}
	if( lsy > ley ){
		i = lsy;
		ley = lsy;
		lsy = i;
	}
	// ẅ悪摜TCY͂ݏoĂȂ`FbNB
	// ͂ݏoĂُI
	if( (lsx < 0) | (lsx >= lImageSizeX) ) return -1;
	if( (lsy < 0) | (lsy >= lImageSizeY) ) return -1;
	if( (lex < 0) | (lex >= lImageSizeX) ) return -1;
	if( (ley < 0) | (ley >= lImageSizeY) ) return -1;

	// 󂯎AhXl|C^
	pImageTop = (unsigned char*)lImageAddress;

	//ϒľvZ
	for( j=lsy; j<ley+1; j++ ){
		for( i=lsx; i<lex+1; i++ ){
			dAverage += *(pImageTop+(j*lImageSizeX)+i);
		}
	}
	dAverage = dAverage / (double)(lex - lsx + 1) / (double)(ley - lsy + 1);
	
	return dAverage;

}
